using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Data;
using CallCenterApi.DB;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Ask_PagerInfo
    /// </summary>
    public partial class T_Ask_PagerInfo
    {
        public T_Ask_PagerInfo()
        { }
        #region  Method
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_PagerId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Ask_PagerInfo");
            strSql.Append(" where F_PagerId=@F_PagerId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_PagerId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_PagerId;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Ask_PagerInfo model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Ask_PagerInfo(");
            strSql.Append("F_CategoryId,F_Title,F_Remark,F_ArrQuestion,F_FullScore,F_Times,F_CreateOn,F_CreateBy,F_ModifyOn,F_ModifyBy,F_DeleteFlag)");
            strSql.Append(" values (");
            strSql.Append("@F_CategoryId,@F_Title,@F_Remark,@F_ArrQuestion,@F_FullScore,@F_Times,@F_CreateOn,@F_CreateBy,@F_ModifyOn,@F_ModifyBy,@F_DeleteFlag)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_CategoryId", SqlDbType.Int,4),
                    new SqlParameter("@F_Title", SqlDbType.VarChar,500),
                    new SqlParameter("@F_Remark", SqlDbType.VarChar,2000),
                    new SqlParameter("@F_ArrQuestion", SqlDbType.VarChar,2000),
                    new SqlParameter("@F_FullScore", SqlDbType.Int,4),
                    new SqlParameter("@F_Times", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateOn", SqlDbType.DateTime),
                    new SqlParameter("@F_CreateBy", SqlDbType.Int,4),
                    new SqlParameter("@F_ModifyOn", SqlDbType.DateTime),
                    new SqlParameter("@F_ModifyBy", SqlDbType.Int,4),
                    new SqlParameter("@F_DeleteFlag", SqlDbType.SmallInt,2)};
            parameters[0].Value = model.F_CategoryId;
            parameters[1].Value = model.F_Title;
            parameters[2].Value = model.F_Remark;
            parameters[3].Value = model.F_ArrQuestion;
            parameters[4].Value = model.F_FullScore;
            parameters[5].Value = model.F_Times;
            parameters[6].Value = model.F_CreateOn;
            parameters[7].Value = model.F_CreateBy;
            parameters[8].Value = model.F_ModifyOn;
            parameters[9].Value = model.F_ModifyBy;
            parameters[10].Value = model.F_DeleteFlag;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Ask_PagerInfo model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Ask_PagerInfo set ");
            strSql.Append("F_CategoryId=@F_CategoryId,");
            strSql.Append("F_Title=@F_Title,");
            strSql.Append("F_Remark=@F_Remark,");
            strSql.Append("F_ArrQuestion=@F_ArrQuestion,");
            strSql.Append("F_FullScore=@F_FullScore,");
            strSql.Append("F_Times=@F_Times,");
            strSql.Append("F_CreateOn=@F_CreateOn,");
            strSql.Append("F_CreateBy=@F_CreateBy,");
            strSql.Append("F_ModifyOn=@F_ModifyOn,");
            strSql.Append("F_ModifyBy=@F_ModifyBy,");
            strSql.Append("F_DeleteFlag=@F_DeleteFlag");
            strSql.Append(" where F_PagerId=@F_PagerId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_CategoryId", SqlDbType.Int,4),
                    new SqlParameter("@F_Title", SqlDbType.VarChar,500),
                    new SqlParameter("@F_Remark", SqlDbType.VarChar,2000),
                    new SqlParameter("@F_ArrQuestion", SqlDbType.VarChar,2000),
                    new SqlParameter("@F_FullScore", SqlDbType.Int,4),
                    new SqlParameter("@F_Times", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateOn", SqlDbType.DateTime),
                    new SqlParameter("@F_CreateBy", SqlDbType.Int,4),
                    new SqlParameter("@F_ModifyOn", SqlDbType.DateTime),
                    new SqlParameter("@F_ModifyBy", SqlDbType.Int,4),
                    new SqlParameter("@F_DeleteFlag", SqlDbType.SmallInt,2),
                    new SqlParameter("@F_PagerId", SqlDbType.Int,4)};
            parameters[0].Value = model.F_CategoryId;
            parameters[1].Value = model.F_Title;
            parameters[2].Value = model.F_Remark;
            parameters[3].Value = model.F_ArrQuestion;
            parameters[4].Value = model.F_FullScore;
            parameters[5].Value = model.F_Times;
            parameters[6].Value = model.F_CreateOn;
            parameters[7].Value = model.F_CreateBy;
            parameters[8].Value = model.F_ModifyOn;
            parameters[9].Value = model.F_ModifyBy;
            parameters[10].Value = model.F_DeleteFlag;
            parameters[11].Value = model.F_PagerId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_PagerId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Ask_PagerInfo ");
            strSql.Append(" where F_PagerId=@F_PagerId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_PagerId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_PagerId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_PagerIdlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Ask_PagerInfo ");
            strSql.Append(" where F_PagerId in (" + F_PagerIdlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Ask_PagerInfo GetModel(int F_PagerId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_PagerId,F_CategoryId,F_Title,F_Remark,F_ArrQuestion,F_FullScore,F_Times,F_CreateOn,F_CreateBy,F_ModifyOn,F_ModifyBy,F_DeleteFlag from T_Ask_PagerInfo ");
            strSql.Append(" where F_PagerId=@F_PagerId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_PagerId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_PagerId;

            CallCenterApi.Model.T_Ask_PagerInfo model = new CallCenterApi.Model.T_Ask_PagerInfo();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                if (ds.Tables[0].Rows[0]["F_PagerId"] != null && ds.Tables[0].Rows[0]["F_PagerId"].ToString() != "")
                {
                    model.F_PagerId = int.Parse(ds.Tables[0].Rows[0]["F_PagerId"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_CategoryId"] != null && ds.Tables[0].Rows[0]["F_CategoryId"].ToString() != "")
                {
                    model.F_CategoryId = int.Parse(ds.Tables[0].Rows[0]["F_CategoryId"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_Title"] != null && ds.Tables[0].Rows[0]["F_Title"].ToString() != "")
                {
                    model.F_Title = ds.Tables[0].Rows[0]["F_Title"].ToString();
                }
                if (ds.Tables[0].Rows[0]["F_Remark"] != null && ds.Tables[0].Rows[0]["F_Remark"].ToString() != "")
                {
                    model.F_Remark = ds.Tables[0].Rows[0]["F_Remark"].ToString();
                }
                if (ds.Tables[0].Rows[0]["F_ArrQuestion"] != null && ds.Tables[0].Rows[0]["F_ArrQuestion"].ToString() != "")
                {
                    model.F_ArrQuestion = ds.Tables[0].Rows[0]["F_ArrQuestion"].ToString();
                }
                if (ds.Tables[0].Rows[0]["F_FullScore"] != null && ds.Tables[0].Rows[0]["F_FullScore"].ToString() != "")
                {
                    model.F_FullScore = int.Parse(ds.Tables[0].Rows[0]["F_FullScore"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_Times"] != null && ds.Tables[0].Rows[0]["F_Times"].ToString() != "")
                {
                    model.F_Times = int.Parse(ds.Tables[0].Rows[0]["F_Times"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_CreateOn"] != null && ds.Tables[0].Rows[0]["F_CreateOn"].ToString() != "")
                {
                    model.F_CreateOn = DateTime.Parse(ds.Tables[0].Rows[0]["F_CreateOn"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_CreateBy"] != null && ds.Tables[0].Rows[0]["F_CreateBy"].ToString() != "")
                {
                    model.F_CreateBy = int.Parse(ds.Tables[0].Rows[0]["F_CreateBy"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_ModifyOn"] != null && ds.Tables[0].Rows[0]["F_ModifyOn"].ToString() != "")
                {
                    model.F_ModifyOn = DateTime.Parse(ds.Tables[0].Rows[0]["F_ModifyOn"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_ModifyBy"] != null && ds.Tables[0].Rows[0]["F_ModifyBy"].ToString() != "")
                {
                    model.F_ModifyBy = int.Parse(ds.Tables[0].Rows[0]["F_ModifyBy"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_DeleteFlag"] != null && ds.Tables[0].Rows[0]["F_DeleteFlag"].ToString() != "")
                {
                    model.F_DeleteFlag = int.Parse(ds.Tables[0].Rows[0]["F_DeleteFlag"].ToString());
                }
                return model;
            }
            else
            {
                return null;
            }
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_PagerId,F_CategoryId,F_Title,F_Remark,F_ArrQuestion,F_FullScore,F_Times,F_CreateOn,F_CreateBy,F_ModifyOn,F_ModifyBy,F_DeleteFlag ");
            strSql.Append(" FROM T_Ask_PagerInfo ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_PagerId,F_CategoryId,F_Title,F_Remark,F_ArrQuestion,F_FullScore,F_Times,F_CreateOn,F_CreateBy,F_ModifyOn,F_ModifyBy,F_DeleteFlag ");
            strSql.Append(" FROM T_Ask_PagerInfo ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Ask_PagerInfo ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_PagerId desc");
            }
            strSql.Append(")AS Row, T.*  from T_Ask_PagerInfo T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetList(int PageSize,int PageIndex,string strWhere)
        {
            SqlParameter[] parameters = {
                    new SqlParameter("@tblName", SqlDbType.VarChar, 255),
                    new SqlParameter("@fldName", SqlDbType.VarChar, 255),
                    new SqlParameter("@PageSize", SqlDbType.Int),
                    new SqlParameter("@PageIndex", SqlDbType.Int),
                    new SqlParameter("@IsReCount", SqlDbType.Bit),
                    new SqlParameter("@OrderType", SqlDbType.Bit),
                    new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
                    };
            parameters[0].Value = "T_Ask_PagerInfo";
            parameters[1].Value = "F_PagerId";
            parameters[2].Value = PageSize;
            parameters[3].Value = PageIndex;
            parameters[4].Value = 0;
            parameters[5].Value = 0;
            parameters[6].Value = strWhere;	
            return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
        }*/

        #endregion  Method
    }
}

